#!hs2
#!load hamster.hsm

#####################################################################
# Skrypt    : Kill_Subject.hsc
# Autor     : Nuta <nuta@konto.pl>
# Strona WWW: http://hamster.thebat.pl
# Wersja    : 2001-05-21
# Poprawki  : 2002-05-13
# ===================================================================
# Opis    : Skrypt usuwajcy wszystkie artykuy z wybranej grupy
#         : news Twojego Hamstera zawierajce podan cz tematu
#         : Peen opis dziaania i instalacji skryptu
#         : zawarty zosta w doczanym pliku Kill_Subject.txt.
#####################################################################

HamRequireVersion("1.3.22.1", True)

Var($Uchwyt, $MaxArt, $NrArt, $TextArt, $Mid, $Subject, $Licz)
Var($AllArt, $MaxAllArt, $Start1, $Stop1, $LiczArt)
Var($Temat, $Ok, $Grupa, $Lista, $Indeks)

repeat

  $Temat = ""
  repeat
    $Temat = InputBox("Wpisz cz tematu kasowanego artykuu (np. x-news):", "Kill_Subject - kasowanie artykuw z fragmentem tematu", $Temat, $Ok)
    if ($Ok=0)
      quit
    endif
  until ($Temat <> "")
  
  $Grupa = ""
  repeat
    $Lista = ListAlloc
    ListLoad($Lista, HamPath + "Groups.hst") 
    $Indeks = ListBox( $Lista, "Wybierz nazw grupy news do analizy:", "Kill_Subject - kasowanie artykuw z fragmentem tematu",, $Ok)
    if ($Ok=0)
      ListFree($Lista)
      quit
    endif
    $Grupa = ListGet($Lista,$Indeks)
    ListFree($Lista)

    $Uchwyt = HamGroupOpen($Grupa)
    if ($Uchwyt < 0)
      MsgBox("Grupa: "+$Grupa+" nie istnieje!"+chr(10)+"Musisz wpisa istniejc w Hamsterze nazw grupy.", "Kill_Subject - kasowanie artykuw z fragmentem tematu", 0x10|0x0)
    endif
  until (($Grupa <> "") && ($Uchwyt >= 0))

  $NrArt = HamArtNoMin($Uchwyt)
  $MaxArt = HamArtNoMax($Uchwyt)
  $AllArt = HamArtCount($Uchwyt)
  $MaxAllArt = $MaxArt-$NrArt
  $LiczArt = 0
  $Licz = 0
  $Start1 = ticks

  print
  if ($AllArt > 0)
    print("Grupa: ",$Grupa," zawiera ",$MaxAllArt+1," artykuw z czego ",$AllArt," niepustych. Prosz czeka...")
  else
    HamGroupClose($Uchwyt)
    print("Grupa: ",$Grupa," nie zawiera niepustych artykuw do analizy!")
    quit
  endif

  while ($NrArt <= $MaxArt)
    $TextArt = HamArtText($Uchwyt, $NrArt)
    if ($TextArt <> "")
      if (pos($Temat, $TextArt) > 0)
        RE_Parse($TextArt, "\n(Subject:)\s+(.+)\r", , $Subject)
        if (pos($Temat, $Subject) > 0)
          RE_Parse($TextArt, "\nMessage-ID:\s+(<.+@.+>)\r", $Mid)
          HamArtDeleteMid($Mid)
          print("Skasowano artyku nr: ",$NrArt,"  M-ID: ",$Mid)
          inc($Licz)
        endif
      endif
      inc($LiczArt)
    endif  
    inc($NrArt)

    $Stop1 = ticks
    if (($Stop1-$Start1) > 30000)
      print("Wykonano ",100-Int(($AllArt-$LiczArt)/($AllArt/100)),"% zadania. Pozostao jeszcze ",$AllArt-$LiczArt," artykuw do analizy. Czekaj...")
      $Start1 = ticks
    endif
  endwhile

  HamGroupClose($Uchwyt)

  print("W grupie: ",$Grupa," znajdowao si ",$AllArt," niepustych artykuw, z ktrych")
  if ($Licz > 0)
    print($Licz," z fragmentem tematu: ",$Temat," skasowano.")
  else
    print("aden nie posiada fragmentu tematu: ",$Temat)
  endif

until (Msgbox("Czy ponawiasz prb dla innego zestawu danych?", "Kill_Subject - kasowanie artykuw z fragmentem tematu",0x20|0x4) = 7)

quit

